//**************************************************************************
//
//
//                       National Institute Of Standards and Technology
//                                    DTS Version 1.1
//         
//                              HTMLFontElement Interface
//**************************************************************************

function HTMLFontElement()
{
   var tests = new Array (HTML0001HFE(),HTML0002HFE(),HTML0003HFE());
   return tests;
}

//------------------------ test case HTML-0001HFE -------------------------
//
// Testing feature - The "color" attribute specifies the font's color. 
//
// Testing approach - Retrieve the first FONT element from the testing
//                    document and examine its "color" attribute.  It should
//                    be set to "#000000" (black).
//
// Semantic Requirements: 1
//
// Last modification date - August 13, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0001HFE()
 {
   var computedValue = "";
   var expectedValue = "#000000";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0001HFE");
    results.description = "The \"color\" attribute specifies the "+
                          "font's color.";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(FONT);
//
// and access its "color" attribute.
//
      computedValue = testNode.node.color;
//
// Write out results 
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}
//------------------------ End test case HTML-0001HFE --------------------------
//
//------------------------   test case HTML-0002HFE ----------------------------
//
// Testing feature - The "face" attribute specifies the font's face
//                   identifier.
//
// Testing approach - Retrieve the first FONT element from the testing
//                    document and examine its "face" attribute.  It should
//                    be set to "ARIAL,HELVITICA".
//
// Semantic Requirements: 2 
//
// Last modification date - August 13, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0002HFE()
 {
   var computedValue = "";
   var expectedValue = "ARIAL,HELVITICA";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0002HFE");
    results.description = "The \"face\" attribute specifies the "+
                          "font's face identifier.";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(FONT);
//
// and access its "face" attribute.
//
      computedValue = testNode.node.face;
      computedValue = computedValue.toUpperCase();
//
// Write out results
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}

//------------------------ End test case HTML-0002HFE --------------------------
//
//------------------------   test case HTML-0003HFE ----------------------------
//
// Testing feature - The "size" attribute specifies the font's size.
//
// Testing approach - Retrieve the first FONT element from the testing
//                    document and examine its "size" attribute.  It should
//                    be set to "4".
//
// Semantic Requirements: 3 
//
// Last modification date - August 16, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0003HFE()
 {
   var computedValue = "";
   var expectedValue = "4";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0003HFE");
    results.description = "The \"size\" attribute specifies the "+
                          "font's size.";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(FONT);
//
// and access its "size" attribute.
//
      computedValue = testNode.node.size;
//
// Write out results
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}

//------------------------ End test case HTML-0003HFE --------------------------
