//**************************************************************************
//
//
//                       National Institute Of Standards and Technology
//                                    DTS Version 1.1
//         
//                              HTMLQuoteElement Interface
//**************************************************************************

function HTMLQuoteElement()
{
   var tests = new Array (HTML0001HQUE(),HTML0002HQUE());
   return tests;
}

//------------------------ test case HTML-0001HQUE -------------------------
//
// Testing feature - The "cite" attribute specifies  a designating document
//                   that designates a source document or message. (test for 
//                   the Q element).
//
// Testing approach - Retrieve the "cite" attribute from the Q
//                    element of the testing document and examine its
//                    value.
//
// Semantic Requirements: 1
//
// Last modification date - September 7, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0001HQUE()
 {
   var computedValue = "";
   var expectedValue = "./FILES/TEST.HTML#Q";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0001HQUE");
    results.description = "The \"cite\" attribute specifies a URI "+
                          "designating a document that designates "+
                          "a source document or message (Q element).";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(Q);
//
// and access its "cite" attribute.
//
      computedValue = testNode.node.cite;
      computedValue = computedValue.toUpperCase();
//
// Write out results 
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}

//------------------------ End test case HTML-0001HQUE -------------------------
//
//------------------------   test case HTML-0002HQUE   -------------------------
//
// Testing feature - The "cite" attribute specifies  a designating document
//                   that designates a source document or message. (test for 
//                   the BLOCKQUOTE element).
//
// Testing approach - Retrieve the "cite" attribute from the BLOCKQUOTE
//                    element of the testing document and examine its
//                    value.
//
// Semantic Requirements: 1
//
// Last modification date - September 7, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0002HQUE()
 {
   var computedValue = "";
   var expectedValue = "./FILES/TEST.HTML#BLOCKQUOTE";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0002HQUE");
    results.description = "The \"cite\" attribute specifies a URI "+
                          "designating a document that designates "+
                          "a source document or message (BLOCKQUOTE "+
                          "element).";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(BLOCKQUOTE);
//
// and access its "cite" attribute.
//
      computedValue = testNode.node.cite;
      computedValue = computedValue.toUpperCase();
//
// Write out results 
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}

//------------------------ End test case HTML-0002HQUE -------------------------
